<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="文章标题" prop="title">
        <el-input
          v-model="queryParams.title"
          placeholder="请输入文章标题"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['system:article:add']"
        >新增</el-button>
      </el-col>

      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="articleList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="文章标题" align="center" prop="title" />
      <el-table-column label="所属栏目" align="center" prop="categoryName" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['system:article:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['system:article:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改文章管理对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="70%" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="文章标题" prop="title">
          <el-input v-model="form.title" placeholder="请输入文章标题" />
        </el-form-item>
          <el-form-item label="内容">
            <editor v-model="form.content" :min-height="192"/>
          </el-form-item>
        <el-form-item label="封面图片" prop="coverImage">
          <el-input disabled v-model="form.coverImage" class="input-with-select">
            <el-button slot="append" @click="openDialog">选择</el-button>
          </el-input>
        </el-form-item>
        <el-form-item label="所属栏目" prop="ids">
          <el-select v-model="form.ids" clearable>
            <el-option v-for="(item, index) in columnList" :key="index"
                       :label="item.categoryName" :value="item.categoryId"></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="标签" prop="tags">
          <el-select v-model="form.tags" clearable>
            <el-option v-for="(item, index) in tagList" :key="index"
                       :label="item.tagName" :value="item.tagId"></el-option>
          </el-select>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
    <materialDialog ref="materialDialog" @selectData="selectData"></materialDialog>
  </div>
</template>

<script>
  import materialDialog from './materialDialog'
import { listArticle, getArticle, delArticle, addArticle, updateArticle } from "@/api/system/article";
import { listCategory } from "@/api/system/category";
import { listTags } from "@/api/system/tags";
export default {
  name: "Article",
  components:{
    materialDialog
  },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 文章管理表格数据
      articleList: [],
      columnList:[], // 所属栏目
      tagList:[], // 标签
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        yhid: null,
        articleRegion: null,
        author: null,
        publishTime: null,
        title: null,
        keywords: null,
        description: null,
        coverImage: null,
        articleModel: null,
        copyFlag: null,
        categoryId: null,
        personalCategory: null,
        link: null,
        staticUrl: null,
        tags: null,
        hit: null,
        replyNum: null,
        upVote: null,
        downVote: null,
        hotFlag: null,
        newFlag: null,
        commentFlag: null,
        topFlag: null,
        favourite: null,
        missionId: null,
        templateName: null,
        available: null,
        deleted: null,
        extra1: null,
        extra2: null,
        extra3: null,
        sort: null,
        onclick: null
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
      }
    };
  },
  created() {
    this.getList();
    // 栏目 标签
    this.getColumList()
  },
  methods: {
    openDialog(){
      this.$refs.materialDialog.init()
    },
    selectData(data){
      this.$set(this.form,'coverImage',data.savePath)
    },
    getColumList(){
      listCategory().then(res=>{
        this.columnList = res.rows
      })
      listTags().then(res=>{
        this.tagList = res.rows
      })
    },
    /** 查询文章管理列表 */
    getList() {
      this.loading = true;
      listArticle(this.queryParams).then(response => {
        this.articleList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        yhid: null,
        articleRegion: null,
        author: null,
        publishTime: null,
        title: null,
        keywords: null,
        description: null,
        coverImage: null,
        articleModel: null,
        copyFlag: null,
        categoryId: null,
        personalCategory: null,
        link: null,
        staticUrl: null,
        tags: null,
        hit: null,
        replyNum: null,
        upVote: null,
        downVote: null,
        hotFlag: null,
        newFlag: null,
        commentFlag: null,
        topFlag: null,
        favourite: null,
        missionId: null,
        templateName: null,
        createTime: null,
        updateTime: null,
        available: null,
        deleted: null,
        extra1: null,
        extra2: null,
        extra3: null,
        sort: null,
        onclick: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加文章管理";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getArticle(id).then(response => {
        this.form = response.data;
        this.form.ids = Number( this.form.categoryId)
        this.form.tags = Number( this.form.tags)
        this.open = true;
        this.title = "修改文章管理";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.form.content=this.$Base64.encode(this.form.content)
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updateArticle(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addArticle(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal.confirm('是否确认删除文章管理编号为"' + ids + '"的数据项？').then(function() {
        return delArticle(ids);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('system/article/export', {
        ...this.queryParams
      }, `article_${new Date().getTime()}.xlsx`)
    }
  }
};
</script>
